VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="_site"

# Base environment for Jekyll
jekyll-base:
    FROM jekyll/jekyll:4
    COPY Gemfile Gemfile.lock .

    RUN chmod -R a+rw Gemfile.lock # `bundle install` may update the lockfile if it's out of sync.

    RUN bundle install

# Build the site
build:
    ARG yama_env="production"

    FROM +jekyll-base

    COPY . .

    RUN chmod -R a+rw Gemfile.lock
    RUN [ -d "$build_dir" ] && chmod -R a+rw $build_dir || true # chmod the build dir if it exists
    RUN [ -d ".jekyll-cache" ] && chmod -R a+rw .jekyll-cache || true # chmod the cache if it exists


    ENV YAMA_ENV=$yama_env

    RUN bundle exec jekyll build --trace -d $build_dir

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir

##################
# Helper targets #
##################

# Update dependencies and save the Gemfile and gems. Run locally with `earthly +update`.
update:
    FROM +jekyll-base

    RUN bundle update

    SAVE ARTIFACT Gemfile AS LOCAL Gemfile
    SAVE ARTIFACT Gemfile.lock AS LOCAL Gemfile.lock
    SAVE ARTIFACT /usr/local/bundle/ AS LOCAL vendor/bundle

# Run the `jekyll serve` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=4000
    ARG container_name="earthly-dev-server"

    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+jekyll-base
            # https://github.com/envygeeks/jekyll-docker/blob/master/README.md#server
            RUN docker run --rm \
                           --volume="$PWD:/srv/jekyll:Z" \
                           --volume="$PWD/vendor/bundle:/usr/local/bundle:Z" \
                           --publish [::1]:$port:4000 \
                           --name="$container_name" \
                           earthly-dev-server-image \
                           jekyll serve --trace
	END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop "$container_name"


################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
